<?php
/** 
*
* @package Auto
* @version $Id: functions.php,v 0.0.1 2007/09/25 17:58:24 vovan Exp $
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/
if (!defined('IN_AUTO'))
{
	exit;
}

function tpldat_gen_options($value, $selected=1)
{
	$r = '';
	foreach($value as $v)
	{
		$r .= "<option value=\"$v[ID]\"" . (($v['ID'] == $selected) ? ' selected ' : '') . ">$v[NAME]</option>";
	}
	return $r;
}

function tpldat_gen_menu_item()
{
	global $db;

	$sql = "SELECT i.id, i.name, i.url, i.title, i.menu_id, i.position
			FROM " . MENU_ITEM_TABLE . " i
			ORDER BY i.menu_id, i.position";
	$db->sql_query($sql);
	$d = $db->sql_fetchrowset();
	$db->sql_freeresult();

	$m = tpldat_get_menu_gr();
	
	foreach($d as $v1)
	{
		$d1[] = upperkey($v1);
	}
	foreach($d1 as $v2)
	{
		$v2['MENU_SELECT'] = tpldat_gen_options($m, $v2['MENU_ID']);
		$d2[] = $v2;
	}
	$d2[] = Array('ID' => '.', 'MENU_SELECT' => tpldat_gen_options($m), 'POSITION' => '1');
	return $d2;
}

function tpldat_get_menu_gr()
{
	global $db;

	$sql = "SELECT m.id, m.name, m.name_fix
			FROM " . MENU_TABLE . " m
			ORDER BY m.name_fix, m.name";
	$db->sql_query($sql);
	$d = $db->sql_fetchrowset();
	$db->sql_freeresult();

	foreach($d as $v1)
{
		$d1[] = upperkey($v1);
}
	return $d1;
}

function delete_menuitem($var)
{
	global $db;
	foreach($var as $k => $v)
	{
		$sql = "DELETE FROM " . MENU_ITEM_TABLE . "
				WHERE id = '" . $db->sql_escape($k) . "'";
		$r = $db->sql_query($sql);
		$db->sql_freeresult();
		if(!$r) return false;
	}
	return true;
}

function submit_menuitem($new)
{
	global $db;

	$sql = "SELECT i.id, i.name, i.url, i.title, i.menu_id, i.position
			FROM " . MENU_ITEM_TABLE . " i
			ORDER BY i.id";
	$db->sql_query($sql);
	$d = $db->sql_fetchrowset();
	$db->sql_freeresult();

	$old = Array();
	foreach($d as $v)
	{
		$old[$v['id']] = Array(	'name' => $v['name'],'url' => $v['url'],'title' => $v['title'],'menu_id' => $v['menu_id'],'position' => $v['position']);
	}

	foreach($old as $k => $v)
	{
		$s = false;

		if($new[$k]['name'] != $v['name'])
			$s['name'] = $db->sql_escape($new[$k]['name']);
		if($new[$k]['url'] != $v['url'])
			$s['url'] = $db->sql_escape($new[$k]['url']);
		if($new[$k]['title'] != $v['title'])
			$s['title'] = $db->sql_escape($new[$k]['title']);
		if($new[$k]['menuid'] != $v['menu_id'])
			$s['menu_id'] = $db->sql_escape($new[$k]['menuid']);
		if($new[$k]['position'] != $v['position'])
			$s['position'] = $db->sql_escape($new[$k]['position']);

		if($s !== false)
		{
			$sql = "UPDATE " . MENU_ITEM_TABLE . "
					SET " . $db->sql_build_array('UPDATE', $s) . "
					WHERE id = " . $db->sql_escape($k);
			$r = $db->sql_query($sql);
			$db->sql_freeresult();
			if(!$r) return false;
		}
	}
	if (preg_match('/[a-za-z_0-9]+/i', $new['.']['name']))
	{

		$d = Array( 'name' => $new['.']['name'],
					'url' => $new['.']['url'],
					'title' => $new['.']['title'],
					'menu_id' => $new['.']['menuid'],
					'position' => $new['.']['position']);
		$sql = "INSERT INTO " . MENU_ITEM_TABLE . $db->sql_build_array('INSERT', $d);
		$r = $db->sql_query($sql);
		$db->sql_freeresult();
		if(!$r) return false;
	}
	return true;
}

function submit_menugroup($new)
{
	global $db;

	$sql = "SELECT m.id, m.name, m.name_fix
			FROM " . MENU_TABLE . " m
			ORDER BY m.name";
	$db->sql_query($sql);
	$d = $db->sql_fetchrowset();
	$db->sql_freeresult();

	$old = Array();
	foreach($d as $v)
	{
		$old[$v['id']] = Array('name' => $v['name'],'name_fix' => $v['name_fix']);
	}

	foreach($old as $k => $v)
	{
		if(!$v['name_fix'] && ($new[$k] != $v['name']) && preg_match('/[a-za-z_0-9]+/i', $new[$k]))
		{
			$sql = "UPDATE " . MENU_TABLE . " m
					SET m.name = '" . $db->sql_escape($new[$k]) . "'
					WHERE m.id = '" . $db->sql_escape($k) . "'";
			$r = $db->sql_query($sql);
			$db->sql_freeresult();
			if(!$r) return false;
		}
		if(!$v['name_fix'] && !preg_match('/[a-za-z_0-9]+/i', $new[$k]))
		{
			$sql = "DELETE FROM " . MENU_TABLE . "
					WHERE id = '" . $db->sql_escape($k) . "'";
			$r = $db->sql_query($sql);
			$db->sql_freeresult();
			if(!$r) return false;
		}
	}


	if (preg_match('/[a-za-z_0-9]+/i', $new['.']['name']))
	{
		$d = Array( 'name' => $new['.']);
		$sql = "INSERT INTO " . MENU_TABLE . $db->sql_build_array('INSERT', $d);
		$r = $db->sql_query($sql);
		$db->sql_freeresult();
		if(!$r) return false;
	}
	return true;
}

function submit_config($vararray)
{
	global $db, $config, $conffix;

	$cx = $conffix;
	$co = $config;
	$cn = $vararray;
	foreach($co as $k => $v)
	{
		if($cn[$k]['value'] != $v)
		{
			$sql = "UPDATE " . CONFIG_TABLE . " c
					SET c.value = '" . $db->sql_escape($cn[$k]['value']) . "'
					WHERE c.name = '" . $db->sql_escape($k) . "'";
			$r = $db->sql_query($sql);
			$db->sql_freeresult();
			if(!$r) return false;
		}
		if((!$cx[$k]) && !preg_match('/[a-za-z_0-9]+/i', $cn[$k]['name']))
		{
			$sql = "DELETE FROM " . CONFIG_TABLE . "
					WHERE name = '" . $db->sql_escape($k) . "'";
			$r = $db->sql_query($sql);
			$db->sql_freeresult();
			if(!$r) return false;
}
		if((!$cx[$k]) && ($cn[$k]['name'] != $k) && preg_match('/[a-za-z_0-9]+/i', $cn[$k]['name']))
		{
			$sql = "UPDATE " . CONFIG_TABLE . " c
					SET c.name = '" . $db->sql_escape($cn[$k]['name']) . "'
					WHERE c.name = '" . $db->sql_escape($k) . "'";
			$r = $db->sql_query($sql);
			$db->sql_freeresult();
			if(!$r) return false;
		}
	}
	if (preg_match('/[a-za-z_0-9]+/i', $cn['.']['name']))
	{
		$d = Array( 'name' => $cn['.']['name'],
					'value' => $cn['.']['value']);
		$sql = "INSERT INTO " . CONFIG_TABLE . $db->sql_build_array('INSERT', $d);
		$r = $db->sql_query($sql);
		$db->sql_freeresult();
		if(!$r) return false;
	}
	return true;
}

?>